
----------- [ Config ] --------

-- Main addon object containing AceEvent
-- We assume you have OBJ:SAVE() and OBJ:LOAD!
local addon_object = MPS

-- When to run as slave.
local SLAVE_PRIO = 2
local SLAVE_NAME = "Macros"
-------------------------------

-- Flag to tell if we are master/slave
local master_flag = 1 

-- Used by MASTER to register slaves
local Slave_que = {}

-- Stupid ipairs will not iterate if we dont pad!
for i=1,100 do Slave_que[i] = "1" end

-- MM = master
-- S = slave
---
--- MM [1] Ping
--- S [2] Here we are!
--- MM [3] Register slave , wait X seconds
--- MM [4] Tell first slave to perform action
--- S [5] Block outgoing messages, Perform action, Reallow messages, send task done to master
--- MM [6] Remove slave from que, GOTO 4, reproccess ADDON que
--- MM [7] Cleaning




-- [1] I am master, ping minions, que them and 
-- then send MSG FROM MASTER
function addon_object:SendAceMsg(...)
	local master_action,master_profile_name = ...
	
	KPS:DebugMsg(SLAVE_NAME.." SendMsg: "..master_action.."BU "..master_profile_name)
	
	if master_flag then
		addon_object:UnregisterMessage("ProfilesHubPing_MASTER")
		KPS:DebugMsg(SLAVE_NAME.." I am master!"..master_action.."BU "..master_profile_name)
		
		-- Reregister in the que
		-- Fixes [6]
		Slave_que[SLAVE_PRIO] = SLAVE_NAME
		
		addon_object:RegisterMessage("Register_slaves")
		-- [1] Ping
		addon_object:SendMessage("ProfilesHubPing_MASTER","Register_slaves",master_action,master_profile_name)
	else
		KPS:DebugMsg(SLAVE_NAME.." I am slave!")
		master_flag = 0
		return -- I am slave: Blocked outgoing messages
	end
end

-- [3] Wait X seconds for slaves and register them
function addon_object:Register_slaves(event,slave,priority,master_action,master_profile_name)
	KPS:DebugMsg(SLAVE_NAME.." Wait 8 secs: "..event,slave,priority,master_action,master_profile_name)
	
	-- Add the slave to the que
	Slave_que[priority] = slave
	
	addon_object:ScheduleTimer("Process_slaves", 3, {master_action,master_profile_name})
end

-- [4] X seconds are up, send action to slaves, when task is finished
-- remove them from que and start again.
function addon_object:Process_slaves(OriginalMessage)
--KPS:DebugMsg(SLAVE_NAME.." StartSlaves > "..OriginalMessage[1],OriginalMessage[2])
	addon_object:UnregisterMessage("Register_slaves")
	
	addon_object:RegisterMessage(SLAVE_NAME,"Slave_worker")
	
	if master_flag then	
		addon_object:RegisterMessage("RemoveSlave")
	end

	master_action,master_profile_name = OriginalMessage[1],OriginalMessage[2]

	for prio,slave in ipairs(Slave_que) do
		
		-- Stupid ipairs will not iterate if we dont pad!
		if slave ~= "1" then
			KPS:DebugMsg(SLAVE_NAME.." Starting slave: "..slave.." prio "..prio..master_action,master_profile_name)
			addon_object:SendMessage(slave,master_action,master_profile_name)
			return
		end
	end
	
	-- [7] All slaves have performed their task, start to clean
	addon_object:UnregisterMessage("RemoveSlave")
		
	-- Listen for masters again
	addon_object:RegisterMessage("ProfilesHubPing_MASTER","RegisterWithMaster")

	KPS:DebugMsg(SLAVE_NAME.." ALL ACTIONS DONE")
	--TODO: * [7] Cleaning
	
	--TODO: Unique Register messages
	--		to avoid conflicts. time + action+name ?
	
	--TODO: Clean up register messages
	
	--TODO: Clean up code
	
	--TODO: DOCUMENTATION
	
	--TODO: RemoveSlave does not work as it should
end

--- ' 	[5] Work as slave.
---		Block outgoing messages, Perform action, Reallow messages, send task done to master
function addon_object:Slave_worker(_,master_action,master_profile_name)
	master_flag = 0 -- Block outgoing messages
	KPS:DebugMsg(SLAVE_NAME.." Slave-work: "..master_flag.." "..master_action.." "..master_profile_name)
	
	
	if master_action == "save" then
		--addon_object:Save(master_profile_name)
		KPS:DebugMsg(SLAVE_NAME.." Slave task done.")
		master_flag = 1
		addon_object:SendMessage("RemoveSlave", master_action, master_profile_name, SLAVE_PRIO )
	end
	
	if master_action == "load" then
		--addon_object:Load(master_profile_name)
		KPS:DebugMsg(SLAVE_NAME.." Slave task done.")
		master_flag = 1
		MPS:SendMessage("RemoveSlave", master_action, master_profile_name, SLAVE_PRIO )
	end
	
	addon_object:UnregisterMessage(SLAVE_NAME)
	addon_object:RegisterMessage("ProfilesHubPing_MASTER","RegisterWithMaster")
	
end

--- * [6] MASTER: Remove slave from que, GOTO 4, reproccess ADDON que
function addon_object:RemoveSlave(event,master_action,master_profile_name, slave)
	-- Slave finished task. Remove from que
		KPS:DebugMsg(SLAVE_NAME.." Slave done: "..Slave_que[slave] ,master_action,master_profile_name)
		
		Slave_que[slave] = "1"
		
		KPS:DebugMsg(Slave_que[slave])
		
		-- Process que until there are no more addons in que
		if master_flag then
			KPS:DebugMsg(SLAVE_NAME.." I am master - Remove slave from my que")
			addon_object:Process_slaves({master_action,master_profile_name})
		end
end

-- DUMMY
function addon_object:BLAH()
	return
end

-- [2] SLAVE: Got pinged , inform master of presence
function addon_object:RegisterWithMaster(_, masters_call,master_action,master_profile_name)
KPS:DebugMsg(SLAVE_NAME.." I am slave: "..masters_call,master_action,master_profile_name)
	
	addon_object:UnregisterMessage("ProfilesHubPing_MASTER")
	addon_object:RegisterMessage(SLAVE_NAME,"Slave_worker")
	addon_object:SendMessage(masters_call,SLAVE_NAME,SLAVE_PRIO,master_action,master_profile_name)
end

addon_object:RegisterMessage("ProfilesHubPing_MASTER","RegisterWithMaster")